/*
 * dircont.h --- dir content functions declaration
 * 
 * Copyright (c) 2022 Mariano Alvarez Fernandez (malfer@telefonica.net)
 *
 * This file is part of FEdit, a visual font editor for the MGRX font format
 *
 * FEdit is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FEdit is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FEdit. If not, see <http://www.gnu.org/licenses/>.
 *
 */

#define DIRC_PATH_MAX 1024
#define DIRC_MAX_DIRS 1000
#define DIRC_MAX_FILES 1000

typedef struct _DirContent {
    char *dirs[DIRC_MAX_DIRS];
    int ndirs;
    char *files[DIRC_MAX_DIRS];
    int nfiles;
    char path[DIRC_PATH_MAX+1];
} DirContent;

DirContent *NewDirContent(void);
void DestroyDirContent(DirContent *dc);
DirContent *GetDirContent(char *dirname);

typedef struct _FNameComp{
    char fname[DIRC_PATH_MAX+1];
    char dname[DIRC_PATH_MAX+1];
    char bname[DIRC_PATH_MAX+1];
} FNameComp;

void SaveCurrentWD(void);
void RestoreCurrentWD(void);
void DecomposeFileName(FNameComp *fnc);
void ComposeFileName(FNameComp *fnc);
