#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#ifdef  __WIN32__
#include <windows.h>
#endif
#include "fdv_grx.h"
#include "rights.h"

char *getrights(char *fname)
{
    FILE *f;
    GrFontFileHeaderGRX fhdr;
    long wtsize, fsize, liclen, i;
    unsigned char c;
    char *license = NULL;

    f = fopen(fname, "rb");
    if (f == NULL) return NULL;

    if (fread(&fhdr,sizeof(fhdr),1,f) != 1) goto end;

    if (fhdr.magic != GRX_FONTMAGIC) goto end;

    wtsize = 0;
    if (!fhdr.isfixed) {
        wtsize = sizeof(short) * (fhdr.maxchar - fhdr.minchar + 1);
    }

    fsize = sizeof(GrFontFileHeaderGRX) + wtsize + fhdr.bmpsize;

    liclen = 0;
    fseek(f, fsize, SEEK_SET);
    while (fread(&c, sizeof(unsigned char), 1, f) == 1) liclen++;
    if (liclen == 0) goto end;

    license = malloc(liclen+1);
    fseek(f, fsize, SEEK_SET);
    for (i=0; i<liclen; i++) {
        fread((unsigned char *)&(license[i]), sizeof(unsigned char), 1, f);
    }
    license[liclen] = '\0';

end:
    fclose(f);
    return license;
}

int putrights(char *fname, char *li)
{
    FILE *f;
    GrFontFileHeaderGRX fhdr;
    long wtsize, fsize;
    int lilen;

    if (li == NULL) return 1;
    lilen = strlen(li);
    if (lilen == 0) return 1;

    f = fopen(fname, "rb+");
    if (f == NULL) return 1;

    if (fread(&fhdr,sizeof(fhdr),1,f) != 1) {
        fclose(f);
        return 1;
    }

    if (fhdr.magic != GRX_FONTMAGIC) {
        fclose(f);
        return 1;
    }

    wtsize = 0;
    if (!fhdr.isfixed) {
        wtsize = sizeof(short) * (fhdr.maxchar - fhdr.minchar + 1);
    }

    fsize = sizeof(GrFontFileHeaderGRX) + wtsize + fhdr.bmpsize;

    fseek(f, fsize, SEEK_SET);

    fwrite(li, lilen, 1, f);

#ifdef  __WIN32__
    HANDLE hf = (HANDLE)_get_osfhandle(_fileno(f));
    SetEndOfFile(hf);
    fclose(f);
#else
    long lastbyte = ftell(f);
    fclose(f);
    truncate(fname, lastbyte);
#endif
    
    return 0;
}
